using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace XNA_HelloPhone2D
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        //Schrift zur Textausgabe
        SpriteFont fntTextAusgabe;
        //Kreis Textur
        Texture2D texKreis;
        //Finger Position
        Vector2 posFinger;
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            // Frame rate is 30 fps by default for Windows Phone.
            TargetElapsedTime = TimeSpan.FromTicks(333333);
            //Vollbild Modus
            graphics.IsFullScreen = true;
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            // TODO: use this.Content to load your game content here
            //SpriteFont laden
            fntTextAusgabe = Content.Load<SpriteFont>("TextAusgabe");
            //Kreistextur laden
            texKreis = Content.Load<Texture2D>("kreis");
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            // TODO: Add your update logic here
            //Alle Eingaben aus dem TouchPanel holen
            TouchCollection touchCollection = TouchPanel.GetState();
            //Alle einzelnen Positionen durchlaufen.
            foreach (TouchLocation tl in touchCollection)
            {
                //Nur wenn der Status gedrückt oder bewegend ist abspeichern
                if ((tl.State == TouchLocationState.Pressed) || (tl.State == TouchLocationState.Moved))
                {
                    posFinger = tl.Position;
                }
            }
            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);
            // TODO: Add your drawing code here
            //Zum zeichnen das spriteBatch Objekt verwenden
            spriteBatch.Begin();
            //Hier erfolgt das zeichnen
            //Kreis in Grün an Position X=10,Y=10
            spriteBatch.Draw(texKreis, new Vector2(10, 10), Color.Green);
            //Kreis in Gelb an Position X=10,Y=10, jedoch um jeweils die Hälfte der Textur-Höhe und Textur-Weite verschoben
            spriteBatch.Draw(texKreis, new Vector2(10 + texKreis.Width / 2, 10 + texKreis.Height / 2), Color.Yellow);
            //Kreis in Blau an Position X=10,Y=10, jedoch um die Textur-Höhe und Textur-Weite verschoben
            spriteBatch.Draw(texKreis, new Vector2(10 + texKreis.Width, 10 + texKreis.Height), Color.Blue);
            //Kreis in Zyan an Position des Fingers malen
            spriteBatch.Draw(texKreis, posFinger, Color.Cyan);
            //Textausgabe
            spriteBatch.DrawString(fntTextAusgabe, "Hallo Windows Phone 7", new Vector2(5, 5), Color.Red);
            //Alle Zeichnen-Operationen durchgeführt
            spriteBatch.End();
            base.Draw(gameTime);
        }
    }
}
